Attribute VB_Name = "mpublic"
'###############################################################
'# Coded By Armin Niki ( Nickname ) for Photormin Open Source  #\
'# ( Supported by SourceForge )                        Project #\
'####### E-mail to Armin3D@gmail.com For More Information ######\
' \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

Public Declare Function ExtFloodFill Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function GetPixel Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDc As Long, ByVal hObject As Long) As Long
Private Declare Function CreateDIBitmap_1 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_1, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_2 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_2, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_4 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_4, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_8 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_8, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_16 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_16, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_24 Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_24, ByVal wUsage As Long) As Long
Private Declare Function CreateDIBitmap_24a Lib "gdi32" Alias "CreateDIBitmap" (ByVal hDc As Long, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, lpInitBits As Any, lpInitInfo As BITMAPINFO_24a, ByVal wUsage As Long) As Long

Public Const ptitle = "Photormin - Version 0.9 Beta"
Public Const OpenFilters = "All Supported Images|*.dib;*.wmf;*.emf;*.jpg;*.jpeg;*.bmp;*.ico;*.cur;*.gif;*.tiff;*.tif;*.pcx;*.png;*.tga;|" & _
"Jpeg Image (JPG)|*.jpg;*.jpeg;|" & _
"Windows Image (WMF, EMF)|*.wmf;*.emf;|" & _
"Bitmap Image (BMP)|*.bmp;|" & _
"Icon File (ICO, CUR)|*.ico;*.cur;|" & _
"GIF Image (GIF)|*.gif;|" & _
"TIFF Image (TIF)|*.tiff;*.tif;|" & _
"PCX Image (PCX)|*.pcx;|" & _
"PNG Image (PNG)|*.png;|" & _
"TGA Image (TGA)|*.tga;|" & _
"All Files|*.*"
Public Const SaveFilters = "Jpeg Image|*.jpg|Bitmap Image|*.bmp|Icon|*.ico|GIF|*.gif"

Public Type COLORRGB
Red As Long
Green As Long
Blue As Long
End Type
Public Type POINTAPI
x As Long
y As Long
End Type
Public strColorChooserTitle As String
Public lngDefaultColor As Long
Public Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Const SRCCOPY = &HCC0020
Private Const BI_RGB = 0&
Private Const CBM_INIT = &H4
Private Const DIB_RGB_COLORS = 0
Public Type RGBTRIPLE
Red As Byte
Green As Byte
Blue As Byte
End Type
Private Type BITMAPINFOHEADER
biSize As Long
biWidth As Long
biHeight As Long
biPlanes As Integer
biBitCount As Integer
biCompression As Long
biSizeImage As Long
biXPelsPerMeter As Long
biYPelsPerMeter As Long
biClrUsed As Long
biClrImportant As Long
End Type
Private Type RGBQUAD
rgbBlue As Byte
rgbGreen As Byte
rgbRed As Byte
rgbReserved As Byte
End Type
Private Type BITMAPINFO_1
bmiHeader As BITMAPINFOHEADER
bmiColors(1) As RGBQUAD
End Type
Private Type BITMAPINFO_2
bmiHeader As BITMAPINFOHEADER
bmiColors(3) As RGBQUAD
End Type
Private Type BITMAPINFO_4
bmiHeader As BITMAPINFOHEADER
bmiColors(15) As RGBQUAD
End Type
Private Type BITMAPINFO_8
bmiHeader As BITMAPINFOHEADER
bmiColors(255) As RGBQUAD
End Type
Private Type BITMAPINFO_16
bmiHeader As BITMAPINFOHEADER
bmiColors As RGBQUAD
End Type
Private Type BITMAPINFO_24
bmiHeader As BITMAPINFOHEADER
bmiColors As RGBQUAD
End Type
Private Type BITMAPINFO_24a
bmiHeader As BITMAPINFOHEADER
bmiColors As RGBTRIPLE
End Type
Private bm1 As BITMAPINFO_1
Private bm2 As BITMAPINFO_2
Private bm4 As BITMAPINFO_4
Private bm8 As BITMAPINFO_8
Private bm16 As BITMAPINFO_16
Private bm24 As BITMAPINFO_24
Private bm24a As BITMAPINFO_24a
Private hBmp As Long 'bitmap handle.
Private Type ScTw
Width As Long
Height As Long
End Type
Private aCRC32Table(255) As Long

'##########################################################################
'### Some Public Function by Armin3D@gmail.com of Photormin Open Source ###
'##########################################################################
Public Function CRC32(sMessage As String) As Long
Dim iCRC As Long
Dim i As Integer
Dim bytT As Byte
Dim bytC As Byte
Dim lngA As Long
Call CRC32Setup
iCRC = &HFFFFFFFF
For i = 1 To Len(sMessage)
bytC = Asc(Mid(sMessage, i, 1))
bytT = (iCRC And &HFF) Xor bytC
lngA = ulShiftRightBy8(iCRC)
iCRC = lngA Xor aCRC32Table(bytT)
Next
CRC32 = iCRC Xor &HFFFFFFFF
End Function
Public Function ulShiftRightBy8(x As Long) As Long
' Shift 32-bit long value to right by 8 bits Avoiding problem with sign bit
Dim iNew As Long
iNew = (x And &H7FFFFFFF) \ 256
If (x And &H80000000) <> 0 Then
iNew = iNew Or &H800000
End If
ulShiftRightBy8 = iNew
End Function
Public Function CRC32Setup()
Static bDone As Boolean
Dim vntA As Variant
Dim i As Integer, iOffset As Integer
Dim nLen As Integer
If bDone Then
Exit Function
End If
iOffset = 0
nLen = 32
' Use variant array kludge to set up table
vntA = Array( _
&H0, &H77073096, &HEE0E612C, &H990951BA, _
&H76DC419, &H706AF48F, &HE963A535, &H9E6495A3, _
&HEDB8832, &H79DCB8A4, &HE0D5E91E, &H97D2D988, _
&H9B64C2B, &H7EB17CBD, &HE7B82D07, &H90BF1D91, _
&H1DB71064, &H6AB020F2, &HF3B97148, &H84BE41DE, _
&H1ADAD47D, &H6DDDE4EB, &HF4D4B551, &H83D385C7, _
&H136C9856, &H646BA8C0, &HFD62F97A, &H8A65C9EC, _
&H14015C4F, &H63066CD9, &HFA0F3D63, &H8D080DF5)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&H3B6E20C8, &H4C69105E, &HD56041E4, &HA2677172, _
&H3C03E4D1, &H4B04D447, &HD20D85FD, &HA50AB56B, _
&H35B5A8FA, &H42B2986C, &HDBBBC9D6, &HACBCF940, _
&H32D86CE3, &H45DF5C75, &HDCD60DCF, &HABD13D59, _
&H26D930AC, &H51DE003A, &HC8D75180, &HBFD06116, _
&H21B4F4B5, &H56B3C423, &HCFBA9599, &HB8BDA50F, _
&H2802B89E, &H5F058808, &HC60CD9B2, &HB10BE924, _
&H2F6F7C87, &H58684C11, &HC1611DAB, &HB6662D3D)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&H76DC4190, &H1DB7106, &H98D220BC, &HEFD5102A, _
&H71B18589, &H6B6B51F, &H9FBFE4A5, &HE8B8D433, _
&H7807C9A2, &HF00F934, &H9609A88E, &HE10E9818, _
&H7F6A0DBB, &H86D3D2D, &H91646C97, &HE6635C01, _
&H6B6B51F4, &H1C6C6162, &H856530D8, &HF262004E, _
&H6C0695ED, &H1B01A57B, &H8208F4C1, &HF50FC457, _
&H65B0D9C6, &H12B7E950, &H8BBEB8EA, &HFCB9887C, _
&H62DD1DDF, &H15DA2D49, &H8CD37CF3, &HFBD44C65)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&H4DB26158, &H3AB551CE, &HA3BC0074, &HD4BB30E2, _
&H4ADFA541, &H3DD895D7, &HA4D1C46D, &HD3D6F4FB, _
&H4369E96A, &H346ED9FC, &HAD678846, &HDA60B8D0, _
&H44042D73, &H33031DE5, &HAA0A4C5F, &HDD0D7CC9, _
&H5005713C, &H270241AA, &HBE0B1010, &HC90C2086, _
&H5768B525, &H206F85B3, &HB966D409, &HCE61E49F, _
&H5EDEF90E, &H29D9C998, &HB0D09822, &HC7D7A8B4, _
&H59B33D17, &H2EB40D81, &HB7BD5C3B, &HC0BA6CAD)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&HEDB88320, &H9ABFB3B6, &H3B6E20C, &H74B1D29A, _
&HEAD54739, &H9DD277AF, &H4DB2615, &H73DC1683, _
&HE3630B12, &H94643B84, &HD6D6A3E, &H7A6A5AA8, _
&HE40ECF0B, &H9309FF9D, &HA00AE27, &H7D079EB1, _
&HF00F9344, &H8708A3D2, &H1E01F268, &H6906C2FE, _
&HF762575D, &H806567CB, &H196C3671, &H6E6B06E7, _
&HFED41B76, &H89D32BE0, &H10DA7A5A, &H67DD4ACC, _
&HF9B9DF6F, &H8EBEEFF9, &H17B7BE43, &H60B08ED5)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&HD6D6A3E8, &HA1D1937E, &H38D8C2C4, &H4FDFF252, _
&HD1BB67F1, &HA6BC5767, &H3FB506DD, &H48B2364B, _
&HD80D2BDA, &HAF0A1B4C, &H36034AF6, &H41047A60, _
&HDF60EFC3, &HA867DF55, &H316E8EEF, &H4669BE79, _
&HCB61B38C, &HBC66831A, &H256FD2A0, &H5268E236, _
&HCC0C7795, &HBB0B4703, &H220216B9, &H5505262F, _
&HC5BA3BBE, &HB2BD0B28, &H2BB45A92, &H5CB36A04, _
&HC2D7FFA7, &HB5D0CF31, &H2CD99E8B, &H5BDEAE1D)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&H9B64C2B0, &HEC63F226, &H756AA39C, &H26D930A, _
&H9C0906A9, &HEB0E363F, &H72076785, &H5005713, _
&H95BF4A82, &HE2B87A14, &H7BB12BAE, &HCB61B38, _
&H92D28E9B, &HE5D5BE0D, &H7CDCEFB7, &HBDBDF21, _
&H86D3D2D4, &HF1D4E242, &H68DDB3F8, &H1FDA836E, _
&H81BE16CD, &HF6B9265B, &H6FB077E1, &H18B74777, _
&H88085AE6, &HFF0F6A70, &H66063BCA, &H11010B5C, _
&H8F659EFF, &HF862AE69, &H616BFFD3, &H166CCF45)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
vntA = Array( _
&HA00AE278, &HD70DD2EE, &H4E048354, &H3903B3C2, _
&HA7672661, &HD06016F7, &H4969474D, &H3E6E77DB, _
&HAED16A4A, &HD9D65ADC, &H40DF0B66, &H37D83BF0, _
&HA9BCAE53, &HDEBB9EC5, &H47B2CF7F, &H30B5FFE9, _
&HBDBDF21C, &HCABAC28A, &H53B39330, &H24B4A3A6, _
&HBAD03605, &HCDD70693, &H54DE5729, &H23D967BF, _
&HB3667A2E, &HC4614AB8, &H5D681B02, &H2A6F2B94, _
&HB40BBE37, &HC30C8EA1, &H5A05DF1B, &H2D02EF8D)
For i = iOffset To iOffset + nLen - 1
aCRC32Table(i) = vntA(i - iOffset)
Next
iOffset = iOffset + nLen
bDone = True
End Function
Public Function TestCRC32()
Dim sMessage As String
Dim iCRC As Long
Call CRC32Setup
sMessage = "123456789"
iCRC = CRC32(sMessage)
Debug.Print "CRC32(" & sMessage & ")=" & Hex(iCRC)
sMessage = "test is"
iCRC = CRC32(sMessage)
Debug.Print "CRC32(" & sMessage & ")=" & Hex(iCRC)
sMessage = "Test is!"
iCRC = CRC32(sMessage)
Debug.Print "CRC32(" & sMessage & ")=" & Hex(iCRC)
sMessage = "a"
iCRC = CRC32(sMessage)
Debug.Print "CRC32(" & sMessage & ")=" & Hex(iCRC)
sMessage = " "
iCRC = CRC32(sMessage)
Debug.Print "CRC32(" & sMessage & ")=" & Hex(iCRC)
End Function
Public Sub InitColorTable_1(Optional Sorting As Integer = 1)
Dim Fb1 As Byte
Dim Fb2 As Byte
Select Case Sorting
Case 0
Fb1 = 255
Fb2 = 0
Case 1
Fb1 = 0
Fb2 = 255
End Select
bm1.bmiColors(0).rgbRed = Fb1
bm1.bmiColors(0).rgbGreen = Fb1
bm1.bmiColors(0).rgbBlue = Fb1
bm1.bmiColors(0).rgbReserved = 0
bm1.bmiColors(1).rgbRed = Fb2
bm1.bmiColors(1).rgbGreen = Fb2
bm1.bmiColors(1).rgbBlue = Fb2
bm1.bmiColors(1).rgbReserved = 0
End Sub
Public Sub InitColorTable_1Palette(Palettenbyte() As Byte)
If UBound(Palettenbyte) = 5 Then
bm1.bmiColors(0).rgbRed = Palettenbyte(0)
bm1.bmiColors(0).rgbGreen = Palettenbyte(1)
bm1.bmiColors(0).rgbBlue = Palettenbyte(2)
bm1.bmiColors(0).rgbReserved = 0
bm1.bmiColors(1).rgbRed = Palettenbyte(3)
bm1.bmiColors(1).rgbGreen = Palettenbyte(4)
bm1.bmiColors(1).rgbBlue = Palettenbyte(5)
bm1.bmiColors(1).rgbReserved = 0
Else
InitColorTable_1
End If
End Sub
Public Sub InitColorTable_8(ByteArray() As Byte)
Dim Palette8() As RGBTRIPLE
ReDim Palette8(255)
CopyMemory Palette8(0), ByteArray(0), UBound(ByteArray) + 1
Dim nCount As Long
On Error Resume Next
For nCount = 0 To 255
bm8.bmiColors(nCount).rgbBlue = Palette8(nCount).Blue
bm8.bmiColors(nCount).rgbGreen = Palette8(nCount).Green
bm8.bmiColors(nCount).rgbRed = Palette8(nCount).Red
bm8.bmiColors(nCount).rgbReserved = 0
Next nCount
End Sub
Public Sub InitColorTable_4(ByteArray() As Byte)
Dim Palette4() As RGBTRIPLE
ReDim Palette4(15)
CopyMemory Palette4(0), ByteArray(0), UBound(ByteArray) + 1
Dim i As Integer
For i = 0 To 15
bm4.bmiColors(i).rgbRed = Palette4(i).Red
bm4.bmiColors(i).rgbGreen = Palette4(i).Green
bm4.bmiColors(i).rgbBlue = Palette4(i).Blue
bm4.bmiColors(i).rgbReserved = 0
Next i
End Sub
Public Sub CreateBitmap_1(ByteArray() As Byte, BMPWidth As Long, BMPHeight As Long, Orientation As Integer, Optional Colorused As Long = 0)
' Create a 1bit Bitmap
Dim hDc As Long
With bm1.bmiHeader
.biSize = Len(bm1.bmiHeader)
.biWidth = BMPWidth
If Orientation = 0 Then
.biHeight = BMPHeight 'Bitmap Height, bitmap is top down.
Else
.biHeight = -BMPHeight
End If
.biPlanes = 1
.biBitCount = 1
.biCompression = BI_RGB
.biSizeImage = 0
.biXPelsPerMeter = 0
.biYPelsPerMeter = 0
.biClrUsed = Colorused
.biClrImportant = 0
End With
hDc = GetDC(0) ' Get the DC.
hBmp = CreateDIBitmap_1(hDc, bm1.bmiHeader, CBM_INIT, ByteArray(0), bm1, DIB_RGB_COLORS)
End Sub
Public Sub CreateBitmap_2(ByteArray() As Byte, BMPWidth As Long, BMPHeight As Long, Orientation As Integer, Optional Colorused As Long = 0)
Dim hDc As Long
With bm1.bmiHeader
.biSize = Len(bm1.bmiHeader)
.biWidth = BMPWidth
If Orientation = 0 Then
.biHeight = BMPHeight 'Bitmap Height, bitmap is top down.
Else
.biHeight = -BMPHeight
End If
.biPlanes = 1
.biBitCount = 2
.biCompression = BI_RGB
.biSizeImage = 0
.biXPelsPerMeter = 0
.biYPelsPerMeter = 0
.biClrUsed = Colorused
.biClrImportant = 0
End With
hDc = GetDC(0)
hBmp = CreateDIBitmap_2(hDc, bm2.bmiHeader, CBM_INIT, ByteArray(0), bm2, DIB_RGB_COLORS)
End Sub

Public Sub CreateBitmap_4(ByteArray() As Byte, picWidth As Long, picHeight As Long, Orientation As Integer, Optional Colorused As Long = 0)
' Creates a device independent bitmap from the pixel data in Data().
Dim hDc As Long
With bm4.bmiHeader
.biSize = Len(bm1.bmiHeader)
.biWidth = picWidth
If Orientation = 0 Then
.biHeight = picHeight 'Bitmap Height, bitmap is top down.
Else
.biHeight = -picHeight
End If
.biPlanes = 1
.biBitCount = 4
.biCompression = BI_RGB
.biSizeImage = 0
.biXPelsPerMeter = 0
.biYPelsPerMeter = 0
.biClrUsed = Colorused
.biClrImportant = 0
End With
hDc = GetDC(0) ' Get the DC.
hBmp = CreateDIBitmap_4(hDc, bm4.bmiHeader, CBM_INIT, ByteArray(0), bm4, DIB_RGB_COLORS)
End Sub
Public Sub CreateBitmap_8(BitmapArray() As Byte, picWidth As Long, picHeight As Long, Orientation As Integer, Optional Colorused As Long = 0)
' Creates a device independent bitmap from the pixel data in BitmapArry().
Dim hDc As Long
With bm8.bmiHeader
.biSize = Len(bm8.bmiHeader)
.biWidth = picWidth
If Orientation = 0 Then
.biHeight = picHeight 'Bitmap Height, bitmap is top down.
Else
.biHeight = -picHeight
End If
.biPlanes = 1
.biBitCount = 8
.biCompression = BI_RGB
.biSizeImage = 0
.biXPelsPerMeter = 0
.biYPelsPerMeter = 0
.biClrUsed = Colorused
.biClrImportant = 0
End With
hDc = GetDC(0) ' Get the DC.
hBmp = CreateDIBitmap_8(hDc, bm8.bmiHeader, CBM_INIT, BitmapArray(0), bm8, DIB_RGB_COLORS)
End Sub
Public Sub DrawBitmap(picWidth As Long, picHeight As Long, PicObject As Object, Scalierung As Boolean, Optional x As Long = 0, Optional y As Long = 0, Optional DrawToBG As Boolean = False)
Dim cDC As Long
Dim a As Long
Dim b As Long
Dim bergabe As ScTw
Dim realheight As Long
Dim realwidth As Long
PicObject.Cls
If TypeOf PicObject Is Form Then
'change ScaleMode direct
Else
b = PicObject.Parent.ScaleMode
PicObject.Parent.ScaleMode = 1
End If
a = PicObject.ScaleMode
PicObject.ScaleMode = 1
Select Case Scalierung
Case True
bergabe = PixelToTwips(picWidth, picHeight)
If DrawToBG = False Then
PicObject.Height = bergabe.Height
PicObject.Width = bergabe.Width
End If
Case False
End Select
If DrawToBG = False Then
If PicObject.Height <> PicObject.ScaleHeight Then 'with Boarders
bergabe = Twipstopixel(PicObject.Width, PicObject.Height)
realheight = bergabe.Height
realwidth = bergabe.Width
PicObject.Height = PicObject.Height + (PicObject.Height - PicObject.ScaleHeight)
PicObject.Width = PicObject.Width + (PicObject.Width - PicObject.ScaleWidth)
Else
PicObject.ScaleMode = 3
realheight = PicObject.ScaleHeight
realwidth = PicObject.ScaleWidth
End If
Else
realheight = bergabe.Height
realwidth = bergabe.Width
picHeight = realheight
picWidth = realwidth
End If
If hBmp Then
cDC = CreateCompatibleDC(PicObject.hDc)
SelectObject cDC, hBmp
Call StretchBlt(PicObject.hDc, x, y, realwidth, realheight, cDC, 0, 0, picWidth, picHeight, SRCCOPY)
DeleteDC cDC
DeleteObject hBmp
hBmp = 0
End If
If TypeOf PicObject Is Form Then
Else 'change ScaleMode direct
PicObject.Parent.ScaleMode = b
End If
PicObject.ScaleMode = a
PicObject.Picture = PicObject.Image
End Sub
Public Sub CreateBitmap_24(ByteArray() As Byte, picWidth As Long, picHeight As Long, Orientation As Integer, Optional ThreeToOrToFour As Integer = 0)
' Creates a device independent bitmap ' from the pixel data in BitmapArray().
Dim hDc As Long
Dim Bits() As RGBQUAD
Dim BitsA() As RGBTRIPLE
Select Case ThreeToOrToFour
Case 0
ReDim Bits((UBound(ByteArray) / 4) - 1)
CopyMemory Bits(0), ByteArray(0), UBound(ByteArray)
With bm24.bmiHeader
.biSize = Len(bm24.bmiHeader)        'SizeOf Struct
.biWidth = picWidth        'Bitmap Width
If Orientation = 0 Then
.biHeight = picHeight                    'Bitmap Height, bitmap is top down.
Else
.biHeight = -picHeight
End If
.biBitCount = 32                        '32 bit alignment
.biPlanes = 1                           'Single plane
.biCompression = BI_RGB                 'No Compression
.biSizeImage = 0                        'Default
.biXPelsPerMeter = 0                    'Default
.biYPelsPerMeter = 0                    'Default
.biClrUsed = 0                          'Default
.biClrImportant = 0                     'Default
End With

Case 1
ReDim BitsA((UBound(ByteArray) / 3) - 1)
CopyMemory BitsA(0), ByteArray(0), UBound(ByteArray)

With bm24a.bmiHeader
.biSize = Len(bm24.bmiHeader)        'SizeOf Struct
.biWidth = picWidth        'Bitmap Width
If Orientation = 0 Then
.biHeight = picHeight                    'Bitmap Height, bitmap is top down.
Else
.biHeight = -picHeight
End If
.biBitCount = 24                        '24 bit alignment
.biPlanes = 1                           'Single plane
.biCompression = BI_RGB                 'No Compression
.biSizeImage = 0                        'Default
.biXPelsPerMeter = 0                    'Default
.biYPelsPerMeter = 0                    'Default
.biClrUsed = 0                          'Default
.biClrImportant = 0                     'Default
End With
End Select
hDc = GetDC(0) ' Get the DC.
Select Case ThreeToOrToFour
Case 0
hBmp = CreateDIBitmap_24(hDc, bm24.bmiHeader, CBM_INIT, Bits(0), bm24, DIB_RGB_COLORS)
Case 1
hBmp = CreateDIBitmap_24a(hDc, bm24a.bmiHeader, CBM_INIT, BitsA(0), bm24a, DIB_RGB_COLORS)
End Select
End Sub
Public Sub CreateBitmap_16(ByteArray() As Byte, picWidth As Long, picHeight As Long, Orientation As Integer)
' Creates a device independent bitmap from the pixel data in BitmapArray().
Dim hDc As Long
With bm16.bmiHeader
.biSize = Len(bm16.bmiHeader) 'SizeOf Struct
.biWidth = picWidth 'Bitmap Width
If Orientation = 0 Then
.biHeight = picHeight 'Bitmap Height, bitmap is top down.
Else
.biHeight = -picHeight
End If
.biPlanes = 1 'Single plane
.biBitCount = 16 '32 bit alignment
.biCompression = BI_RGB 'No Compression
.biSizeImage = 0 'Default
.biXPelsPerMeter = 0 'Default
.biYPelsPerMeter = 0 'Default
.biClrUsed = 0 'Default
.biClrImportant = 0 'Default
End With
hDc = GetDC(0) ' Get the DC.
hBmp = CreateDIBitmap_16(hDc, bm16.bmiHeader, CBM_INIT, ByteArray(0), bm16, DIB_RGB_COLORS)
End Sub
Private Function PixelToTwips(xwert As Long, ywert As Long) As ScTw
Dim ux As Long
Dim uy As Long
Dim XWert1 As Long
Dim yWert1 As Long
ux = Screen.TwipsPerPixelX
PixelToTwips.Width = xwert * ux
uy = Screen.TwipsPerPixelY
PixelToTwips.Height = ywert * uy
End Function
Public Function Twipstopixel(xwert As Long, ywert As Long) As ScTw
Dim ux As Long
Dim uy As Long
Dim XWert1 As Long
Dim yWert1 As Long
ux = Screen.TwipsPerPixelX
Twipstopixel.Width = xwert / ux
uy = Screen.TwipsPerPixelY
Twipstopixel.Height = ywert / uy
End Function
Public Function InitColorTable_Grey(BitDepth As Integer, Optional To8Bit As Boolean = False) As Byte()
Dim CurLevel As Integer
Dim bergabe() As Byte
Dim N As Long
Dim LevelDiff As Byte
Dim Tbl() As RGBQUAD
Dim Table3() As RGBTRIPLE
Erase bm8.bmiColors
If BitDepth <> 16 Then
ReDim Tbl(2 ^ BitDepth - 1)
ReDim Table3(2 ^ BitDepth - 1)
Else
ReDim Tbl(255)
ReDim Table3(255)
End If
LevelDiff = 255 / UBound(Tbl)
For N = 0 To UBound(Tbl)
With Tbl(N)
.rgbRed = CurLevel
.rgbGreen = CurLevel
.rgbBlue = CurLevel
End With
With Table3(N)
.Red = CurLevel
.Green = CurLevel
.Blue = CurLevel
End With
CurLevel = CurLevel + LevelDiff
Next N
Select Case BitDepth
Case 1
If To8Bit = True Then
CopyMemory ByVal VarPtr(bm8.bmiColors(0).rgbBlue), ByVal VarPtr(Tbl(0).rgbBlue), 8
End If
Case 2
CopyMemory ByVal VarPtr(bm8.bmiColors(0).rgbBlue), ByVal VarPtr(Tbl(0).rgbBlue), 16
Case 4
If To8Bit = True Then
CopyMemory ByVal VarPtr(bm8.bmiColors(0).rgbBlue), ByVal VarPtr(Tbl(0).rgbBlue), 64
Else
CopyMemory ByVal VarPtr(bm4.bmiColors(0).rgbBlue), ByVal VarPtr(Tbl(0).rgbBlue), 64
End If
Case 8
CopyMemory ByVal VarPtr(bm8.bmiColors(0).rgbBlue), ByVal VarPtr(Tbl(0).rgbBlue), 1024
End Select
ReDim bergabe(((UBound(Table3) + 1) * 3) - 1)
CopyMemory bergabe(0), ByVal VarPtr(Table3(0).Red), ((UBound(Table3) + 1) * 3)
InitColorTable_Grey = bergabe
End Function
Public Function ShowColor(Optional Title As String, Optional DefaultColor As Long) As Long
lngDefaultColor = DefaultColor
Load frmMain
frmColorC.Show 1, frmMain
ShowColor = frmColorC.Color
End Function
Public Function SaveJPEG(ByVal Filename As String, pic As PictureBox, Optional ByVal Overwrite As Boolean = True, Optional ByVal Quality As Byte = 90) As Boolean
Dim JPEGclass As cJpeg
Dim m_Picture As IPictureDisp
Dim m_DC As Long
Dim m_Millimeter As Single
m_Millimeter = 26.45836
Set m_Picture = pic
m_DC = pic.hDc
Set JPEGclass = New cJpeg
If m_DC <> 0 And LenB(Filename) > 0 Then 'check there is image to save and the filename string is not empty
If Quality < 1 Then Quality = 1 'check for valid quality
If Quality > 100 Then Quality = 100
JPEGclass.Quality = Quality 'set quality
JPEGclass.SetSamplingFrequencies 1, 1, 1, 1, 1, 1 'save in full color
If JPEGclass.SampleHDC(m_DC, CLng(m_Picture.Width / m_Millimeter), CLng(m_Picture.Height / m_Millimeter)) = 0 Then 'copy image from hDC
If Overwrite And LenB(Dir$(Filename)) > 0 Then Kill Filename 'if overwrite is set and file exists, delete the file
SaveJPEG = JPEGclass.SaveFile(Filename) = 0 'save file and return True if success
End If
End If
Set JPEGclass = Nothing 'clear memory
End Function
Public Function GenerateIconForSave(ByRef PicBox As PictureBox) As String
'method for generating the binary data required for TRUE COLOR(!) icons
Dim arrx() As String, isTr As Boolean
Dim x As Integer, y As Integer, s As String
Dim width_in_pixels As Integer, height_in_pixels As Integer
Dim l As Long, r As Integer, g As Integer, b As Integer
PicBox.ScaleMode = vbPixels
width_in_pixels = PicBox.ScaleWidth
height_in_pixels = PicBox.ScaleHeight
ReDim arrx(height_in_pixels - 1, 3) As String
For y = height_in_pixels - 1 To 0 Step -1 'icons are saved from top to bottom
For x = 0 To width_in_pixels - 1         'and left to right
l = PicBox.Point(x, y)
r = GetRGB(l).Red
g = GetRGB(l).Green
b = GetRGB(l).Blue
If r < 0 Then r = 0
If g < 0 Then g = 0
If b < 0 Then b = 0
If l = PicBox.BackColor Then
s = s & Chr(0) & Chr(0) & Chr(0)
isTr = True
Else
s = s & Chr(b) & Chr(g) & Chr(r)
End If
Next x
Next y
If isTr = True Then 'transparent
For y = height_in_pixels - 1 To 0 Step -1 'populate transparent data array
For x = 0 To 3                           'to make sure that'll fill properly for 16x16 icons
arrx(y, x) = "-1"
Next x
Next y
For y = 0 To height_in_pixels - 1 'check for transparency
For x = 0 To width_in_pixels - 1
l = PicBox.Point(x, y)
If l = PicBox.BackColor Then 'generate transparent string for transsolution function
If arrx(y, Int(x / 8)) = "-1" Then arrx(y, Int(x / 8)) = ""
arrx(y, Int(x / 8)) = arrx(y, Int(x / 8)) & "1"
Else
If arrx(y, Int(x / 8)) = "-1" Then arrx(y, Int(x / 8)) = ""
arrx(y, Int(x / 8)) = arrx(y, Int(x / 8)) & "0"
End If
Next x
Next y
Dim f As String, e As Integer
For y = height_in_pixels - 1 To 0 Step -1 'create generated transparent data
For x = 0 To 3
If arrx(y, x) = "-1" Then e = 255 Else e = TransSolution(arrx(y, x))
f = f & Chr(e)
Next x
Next y
End If
s = s & f
'fill data with chr(0) if there is no transparency
s = s & String(((width_in_pixels * width_in_pixels) * 3) + ((width_in_pixels / 4) * width_in_pixels) - Len(s), Chr(0))
If width_in_pixels = 16 Then '16x16 icon
GenerateIconForSave = String(2, Chr(0)) & Chr(1) & Chr(0) & Chr(1) & Chr(0) & Chr(width_in_pixels) & Chr(height_in_pixels) & String(6, Chr(0)) & Chr(Val("&H68")) & Chr(3) & String(2, Chr(0)) & Chr(22) & String(3, Chr(0)) & Chr(40) & String(3, Chr(0)) & Chr(16) & String(3, Chr(0)) & Chr(32) & String(3, Chr(0)) & Chr(1) & Chr(0) & Chr(24) & String(5, Chr(0)) & Chr(64) & Chr(3) & String(18, Chr(0)) & s
ElseIf width_in_pixels = 32 Then '32x32 icon
GenerateIconForSave = String(2, Chr(0)) & Chr(1) & Chr(0) & Chr(1) & Chr(0) & Chr(width_in_pixels) & Chr(height_in_pixels) & String(6, Chr(0)) & Chr(Val("&HA8")) & Chr(12) & String(2, Chr(0)) & Chr(22) & String(3, Chr(0)) & Chr(40) & String(3, Chr(0)) & Chr(32) & String(3, Chr(0)) & Chr(64) & String(3, Chr(0)) & Chr(1) & Chr(0) & Chr(24) & String(6, Chr(0)) & Chr(12) & String(18, Chr(0)) & s
Else
Err.Raise 10001, , "Unsupported Icon Size"
End If
End Function
Public Function GetRGB(ByVal CVal As Long) As COLORRGB
GetRGB.Blue = Int(CVal / 65536)
GetRGB.Green = Int((CVal - (65536 * GetRGB.Blue)) / 256)
GetRGB.Red = CVal - (65536 * GetRGB.Blue + 256 * GetRGB.Green)
End Function
Private Function TransSolution(ByVal s As String) As Integer
If s = "00000000" Then TransSolution = 0: Exit Function
Dim b As Integer, c As Integer, a As String
Dim arrBase(7) As Single
For i = 7 To 0 Step -1
a = Mid(s, i + 1, 1)
If a = "1" Then b = 7 - i
Next i
arrBase(0) = 1
c = -1
For i = 0 To b
arrBase(0) = arrBase(0) + arrBase(0)
If i < b Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then c = i
End If
Next i
arrBase(1) = 1
b = -1
For i = 0 To c
arrBase(1) = arrBase(1) + arrBase(1)
If i < c Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then b = i
End If
Next i
arrBase(2) = 1
c = -1
For i = 0 To b
arrBase(2) = arrBase(2) + arrBase(2)
If i < b Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then c = i
End If
Next i
arrBase(3) = 1
b = -1
For i = 0 To c
arrBase(3) = arrBase(3) + arrBase(3)
If i < c Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then b = i
End If
Next i
arrBase(4) = 1
c = -1
For i = 0 To b
arrBase(4) = arrBase(4) + arrBase(4)
If i < b Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then c = i
End If
Next i
arrBase(5) = 1
b = -1
For i = 0 To c
arrBase(5) = arrBase(5) + arrBase(5)
If i < c Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then b = i
End If
Next i
arrBase(6) = 1
c = -1
For i = 0 To b
arrBase(6) = arrBase(6) + arrBase(6)
If i < b Then
a = Mid(s, (7 - i) + 1, 1)
If a = "1" Then c = i
End If
Next i
If c = 0 Then arrBase(6) = arrBase(6) + 2
Dim base_number As Integer
Dim base2_number As Integer
Dim base3_number As Integer
Dim base4_number As Integer
Dim base5_number As Integer
Dim base6_number As Integer
Dim base7_number As Integer
base_number = CInt(arrBase(0) / 2)
base2_number = CInt(arrBase(1) / 2)
base3_number = CInt(arrBase(2) / 2)
base4_number = CInt(arrBase(3) / 2)
base5_number = CInt(arrBase(4) / 2)
base6_number = CInt(arrBase(5) / 2)
base7_number = CInt(arrBase(6) / 2)
TransSolution = base_number + base2_number + base3_number + base4_number + base5_number + base6_number + base7_number
End Function
